package eu.dnetlib.uoamonitorservice.entities;

import eu.dnetlib.uoamonitorservice.dto.SectionFull;
import eu.dnetlib.uoamonitorservice.generics.SectionGeneric;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

@Document
public class Section extends SectionGeneric<String> {
    public Section() {}

    public Section(SectionFull section) {
        super(section);
        this.indicators = section.getIndicators().stream().map(Indicator::getId).collect(Collectors.toList());
        this.indicators.removeIf(Objects::isNull);
    }
}
